<template>
  <a-space style="margin-bottom: 20px">
    <SelectUser
      style="margin-left: 10px"
      v-if="hasRole('superAdmin') || hasRole('admin')"
      :placeholder="`添加成员`"
      @done="addCompanyExpUser"
    />
    <a-button>邀请添加</a-button>
  </a-space>
  <div class="content">
    <table class="ele-table ele-table-border ele-table-stripe ele-table-medium">
      <thead>
        <tr>
          <th>用户ID</th>
          <th>角色</th>
          <th>昵称</th>
          <th>加入时间</th>
          <th>操作</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(user, index) in data.userList" :key="index">
          <td>{{ user.userId }}</td>
          <td>
            <span v-if="user.role === 10">普通成员</span>
            <span v-if="user.role === 20">管理成员</span>
            <span v-if="user.role === 30">所有者</span>
          </td>
          <td>
            <span style="padding-left: 5px">{{ user.nickname }}</span>
          </td>
          <td>{{ user.createTime }}</td>
          <td>
            <div v-if="user.role !== 30">
              <a
                @click="removeUser(user)"
                v-if="hasRole('superAdmin') || hasRole('admin')"
              >
                移除
              </a>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script lang="ts" setup>
  import { User } from '@/api/system/user/model';
  import { Company } from '@/api/oa/company/model';
  import { hasRole } from '@/utils/permission';
  import { CompanyUser } from '@/api/oa/company/user/model';
  import { addCompanyUser, removeCompanyUser } from '@/api/oa/company/user';
  import { message } from 'ant-design-vue';

  const props = defineProps<{
    companyId: any;
    data: Company;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 添加开发成员
  const addCompanyDevUser = (data: User) => {
    addCompanyUser({
      userId: data.userId,
      companyId: props.data?.companyId,
      role: 20
    })
      .then((msg) => {
        message.success(msg);
        emit('done');
      })
      .catch((e) => {
        message.error(e.message);
      });
  };

  // 添加体验成员
  const addCompanyExpUser = (data: User) => {
    addCompanyUser({
      userId: data.userId,
      companyId: props.data?.companyId,
      role: 10
    })
      .then((msg) => {
        message.success(msg);
        emit('done');
      })
      .catch((e) => {
        message.error(e.message);
      });
  };

  // 移除成员
  const removeUser = (data: CompanyUser) => {
    removeCompanyUser(data.companyUserId)
      .then((msg) => {
        message.success(msg);
        emit('done');
      })
      .catch((e) => {
        message.error(e.message);
      });
  };
</script>
